library ieee;
library ieee; -- inserted by analyzer due to library renaming.
use ieee.std_logic_1164.all;
package vital_timing is
type vitaltransitiontype is (tr01, tr10, tr0z, trz1, tr1z, trz0, tr0x, trx1, tr1x, trx0, trxz, trzx);
subtype vitaldelaytype is time;
type vitaldelaytype01 is array  ( vitaltransitiontype range tr01 to tr10 )  of time;
type vitaldelaytype01z is array  ( vitaltransitiontype range tr01 to trz0 )  of time;
type vitaldelaytype01zx is array  ( vitaltransitiontype range tr01 to trzx )  of time;
type vitaldelayarraytype is array  ( natural range <> )  of vitaldelaytype;
type vitaldelayarraytype01 is array  ( natural range <> )  of vitaldelaytype01;
type vitaldelayarraytype01z is array  ( natural range <> )  of vitaldelaytype01z;
type vitaldelayarraytype01zx is array  ( natural range <> )  of vitaldelaytype01zx;
 constant vitalzerodelay : vitaldelaytype := 0 ns;
 constant vitalzerodelay01 : vitaldelaytype01 :=  ( 0 ns, 0 ns ) ;
 constant vitalzerodelay01z : vitaldelaytype01z :=  ( others => 0 ns ) ;
 constant vitalzerodelay01zx : vitaldelaytype01zx :=  ( others => 0 ns ) ;
attribute vital_level0 : boolean;
attribute vital_level1 : boolean;
subtype std_logic_vector2 is std_logic_vector ( 1 downto 0 ) ;
subtype std_logic_vector3 is std_logic_vector ( 2 downto 0 ) ;
subtype std_logic_vector4 is std_logic_vector ( 3 downto 0 ) ;
subtype std_logic_vector8 is std_logic_vector ( 7 downto 0 ) ;
type vitaloutputmaptype is array  ( std_ulogic )  of std_ulogic;
type vitalresultmaptype is array  ( ux01 )  of std_ulogic;
type vitalresultzmaptype is array  ( ux01z )  of std_ulogic;
 constant vitaldefaultoutputmap : vitaloutputmaptype := "UX01ZWLH-";
 constant vitaldefaultresultmap : vitalresultmaptype :=  ( 'U', 'X', '0', '1' ) ;
 constant vitaldefaultresultzmap : vitalresultzmaptype :=  ( 'U', 'X', '0', '1', 'Z' ) ;
type vitaltimearrayt is array  ( integer range <> )  of time;
type vitaltimearraypt is access vitaltimearrayt;
type vitalboolarrayt is array  ( integer range <> )  of boolean;
type vitalboolarraypt is access vitalboolarrayt;
type vitallogicarraypt is access std_logic_vector;
type vitaltimingdatatype is 
record
 notfirstflag : boolean;
reflast : x01;
reftime : time;
holden : boolean;
testlast : std_ulogic;
testtime : time;
setupen : boolean;
testlasta : vitallogicarraypt;
testtimea : vitaltimearraypt;
holdena : vitalboolarraypt;
setupena : vitalboolarraypt;

end record;
function vitaltimingdatainit return vitaltimingdatatype;
type vitalperioddatatype is 
record
 last : x01;
rise : time;
fall : time;
notfirstflag : boolean;

end record;
 constant vitalperioddatainit : vitalperioddatatype :=  ( 'X', 0 ns, 0 ns, false ) ;
type vitalglitchkindtype is (onevent, ondetect, vitalinertial, vitaltransport);
type vitalglitchdatatype is 
record
 schedtime : time;
glitchtime : time;
schedvalue : std_ulogic;
lastvalue : std_ulogic;

end record;
type vitalglitchdataarraytype is array  ( natural range <> )  of vitalglitchdatatype;
type vitalpathtype is 
record
 inputchangetime : time;
pathdelay : vitaldelaytype;
pathcondition : boolean;

end record;
type vitalpath01type is 
record
 inputchangetime : time;
pathdelay : vitaldelaytype01;
pathcondition : boolean;

end record;
type vitalpath01ztype is 
record
 inputchangetime : time;
pathdelay : vitaldelaytype01z;
pathcondition : boolean;

end record;
type vitalpatharraytype is array  ( natural range <> )  of vitalpathtype;
type vitalpatharray01type is array  ( natural range <> )  of vitalpath01type;
type vitalpatharray01ztype is array  ( natural range <> )  of vitalpath01ztype;
type vitaltablesymboltype is ('/', '\', 'P', 'N', 'r', 'f', 'p', 'n', 'R', 'F', '^', 'v', 'E', 'A', 'D', '*', 'X', '0', '1', '-', 'B', 'Z', 'S');
subtype vitaledgesymboltype is vitaltablesymboltype range '/'  to  '*';
type vitalskewexpectedtype is (none, s1r, s1f, s2r, s2f);
type vitalskewdatatype is 
record
 expectedtype : vitalskewexpectedtype;
signal1old1 : time;
signal2old1 : time;
signal1old2 : time;
signal2old2 : time;

end record;
 constant vitalskewdatainit : vitalskewdatatype :=  ( none, 0 ns, 0 ns, 0 ns, 0 ns ) ;
function vitalextendtofilldelay (constant delay : in vitaldelaytype) return vitaldelaytype01z;
function vitalextendtofilldelay (constant delay : in vitaldelaytype01) return vitaldelaytype01z;
function vitalextendtofilldelay (constant delay : in vitaldelaytype01z) return vitaldelaytype01z;
function vitalcalcdelay (constant newval : in std_ulogic := 'X'; constant oldval : in std_ulogic := 'X'; constant delay : in vitaldelaytype) return time;
function vitalcalcdelay (constant newval : in std_ulogic := 'X'; constant oldval : in std_ulogic := 'X'; constant delay : in vitaldelaytype01) return time;
function vitalcalcdelay (constant newval : in std_ulogic := 'X'; constant oldval : in std_ulogic := 'X'; constant delay : in vitaldelaytype01z) return time;
procedure vitalpathdelay( signal outsignal : out std_logic;  variable glitchdata : inout vitalglitchdatatype; constant outsignalname : in string; constant outtemp : in std_logic; constant paths : in vitalpatharraytype; constant defaultdelay : in vitaldelaytype := vitalzerodelay; constant mode : in vitalglitchkindtype := onevent; constant xon : in boolean := true; constant msgon : in boolean := true; constant msgseverity : in severity_level := warning; constant negpreempton : in boolean := false; constant ignoredefaultdelay : in boolean := false);
procedure vitalpathdelay01( signal outsignal : out std_logic;  variable glitchdata : inout vitalglitchdatatype; constant outsignalname : in string; constant outtemp : in std_logic; constant paths : in vitalpatharray01type; constant defaultdelay : in vitaldelaytype01 := vitalzerodelay01; constant mode : in vitalglitchkindtype := onevent; constant xon : in boolean := true; constant msgon : in boolean := true; constant msgseverity : in severity_level := warning; constant negpreempton : in boolean := false; constant ignoredefaultdelay : in boolean := false; constant rejectfastpath : in boolean := false);
procedure vitalpathdelay01z( signal outsignal : out std_logic;  variable glitchdata : inout vitalglitchdatatype; constant outsignalname : in string; constant outtemp : in std_logic; constant paths : in vitalpatharray01ztype; constant defaultdelay : in vitaldelaytype01z := vitalzerodelay01z; constant mode : in vitalglitchkindtype := onevent; constant xon : in boolean := true; constant msgon : in boolean := true; constant msgseverity : in severity_level := warning; constant outputmap : in vitaloutputmaptype := vitaldefaultoutputmap; constant negpreempton : in boolean := false; constant ignoredefaultdelay : in boolean := false; constant rejectfastpath : in boolean := false);
procedure vitalwiredelay( signal outsig : out std_ulogic;  signal insig : in std_ulogic; constant twire : in vitaldelaytype);
procedure vitalwiredelay( signal outsig : out std_ulogic;  signal insig : in std_ulogic; constant twire : in vitaldelaytype01);
procedure vitalwiredelay( signal outsig : out std_ulogic;  signal insig : in std_ulogic; constant twire : in vitaldelaytype01z);
procedure vitalsignaldelay( signal outsig : out std_ulogic;  signal insig : in std_ulogic; constant dly : in time);
procedure vitalsetupholdcheck( variable violation : out x01;  variable timingdata : inout vitaltimingdatatype;  signal testsignal : in std_ulogic; constant testsignalname : in string := ""; constant testdelay : in time := 0 ns;  signal refsignal : in std_ulogic; constant refsignalname : in string := ""; constant refdelay : in time := 0 ns; constant setuphigh : in time := 0 ns; constant setuplow : in time := 0 ns; constant holdhigh : in time := 0 ns; constant holdlow : in time := 0 ns; constant checkenabled : in boolean := true; constant reftransition : in vitaledgesymboltype; constant headermsg : in string := " "; constant xon : in boolean := true; constant msgon : in boolean := true; constant msgseverity : in severity_level := warning; constant enablesetupontest : in boolean := true; constant enablesetuponref : in boolean := true; constant enableholdonref : in boolean := true; constant enableholdontest : in boolean := true);
procedure vitalsetupholdcheck( variable violation : out x01;  variable timingdata : inout vitaltimingdatatype;  signal testsignal : in std_logic_vector; constant testsignalname : in string := ""; constant testdelay : in time := 0 ns;  signal refsignal : in std_ulogic; constant refsignalname : in string := ""; constant refdelay : in time := 0 ns; constant setuphigh : in time := 0 ns; constant setuplow : in time := 0 ns; constant holdhigh : in time := 0 ns; constant holdlow : in time := 0 ns; constant checkenabled : in boolean := true; constant reftransition : in vitaledgesymboltype; constant headermsg : in string := " "; constant xon : in boolean := true; constant msgon : in boolean := true; constant msgseverity : in severity_level := warning; constant enablesetupontest : in boolean := true; constant enablesetuponref : in boolean := true; constant enableholdonref : in boolean := true; constant enableholdontest : in boolean := true);
procedure vitalrecoveryremovalcheck( variable violation : out x01;  variable timingdata : inout vitaltimingdatatype;  signal testsignal : in std_ulogic; constant testsignalname : in string := ""; constant testdelay : in time := 0 ns;  signal refsignal : in std_ulogic; constant refsignalname : in string := ""; constant refdelay : in time := 0 ns; constant recovery : in time := 0 ns; constant removal : in time := 0 ns; constant activelow : in boolean := true; constant checkenabled : in boolean := true; constant reftransition : in vitaledgesymboltype; constant headermsg : in string := " "; constant xon : in boolean := true; constant msgon : in boolean := true; constant msgseverity : in severity_level := warning; constant enablerecontest : in boolean := true; constant enablereconref : in boolean := true; constant enableremonref : in boolean := true; constant enableremontest : in boolean := true);
procedure vitalperiodpulsecheck( variable violation : out x01;  variable perioddata : inout vitalperioddatatype;  signal testsignal : in std_ulogic; constant testsignalname : in string := ""; constant testdelay : in time := 0 ns; constant period : in time := 0 ns; constant pulsewidthhigh : in time := 0 ns; constant pulsewidthlow : in time := 0 ns; constant checkenabled : in boolean := true; constant headermsg : in string := " "; constant xon : in boolean := true; constant msgon : in boolean := true; constant msgseverity : in severity_level := warning);
procedure vitalinphaseskewcheck( variable violation : out x01;  variable skewdata : inout vitalskewdatatype;  signal signal1 : in std_ulogic; constant signal1name : in string := ""; constant signal1delay : in time := 0 ns;  signal signal2 : in std_ulogic; constant signal2name : in string := ""; constant signal2delay : in time := 0 ns; constant skews1s2riserise : in time := time'HIGH(1); constant skews2s1riserise : in time := time'HIGH(1); constant skews1s2fallfall : in time := time'HIGH(1); constant skews2s1fallfall : in time := time'HIGH(1); constant checkenabled : in boolean := true; constant xon : in boolean := true; constant msgon : in boolean := true; constant msgseverity : in severity_level := warning; constant headermsg : in string := "";  signal trigger : inout std_ulogic);
procedure vitaloutphaseskewcheck( variable violation : out x01;  variable skewdata : inout vitalskewdatatype;  signal signal1 : in std_ulogic; constant signal1name : in string := ""; constant signal1delay : in time := 0 ns;  signal signal2 : in std_ulogic; constant signal2name : in string := ""; constant signal2delay : in time := 0 ns; constant skews1s2risefall : in time := time'HIGH(1); constant skews2s1risefall : in time := time'HIGH(1); constant skews1s2fallrise : in time := time'HIGH(1); constant skews2s1fallrise : in time := time'HIGH(1); constant checkenabled : in boolean := true; constant xon : in boolean := true; constant msgon : in boolean := true; constant msgseverity : in severity_level := warning; constant headermsg : in string := "";  signal trigger : inout std_ulogic);
end package;
